## distribution specific definitions
%define use_systemd (0%{?fedora} && 0%{?fedora} >= 18) || (0%{?rhel} && 0%{?rhel} >= 7) || (0%{?suse_version} == 1315)

%if 0%{?rhel} == 5
%define _group System Environment/Daemons
Requires(pre): shadow-utils
Requires: initscripts >= 8.36
Requires(post): chkconfig
Requires: openssl
Requires: openssh-server >= 4.4
BuildRequires: openssl-devel
%endif

%if 0%{?rhel} == 6
%define _group System Environment/Daemons
Requires(pre): shadow-utils
Requires: initscripts >= 8.36
Requires(post): chkconfig
Requires: openssl >= 1.0.1
Requires: openssh-server >= 4.4
BuildRequires: openssl-devel >= 1.0.1
%endif

%if 0%{?rhel} == 7
%define _group System Environment/Daemons
%define epoch 1
Epoch: %{epoch}
Requires(pre): shadow-utils
Requires: systemd
Requires: openssl >= 1.0.1
Requires: openssh-server >= 4.4
BuildRequires: systemd-units
BuildRequires: openssl-devel >= 1.0.1
%endif

%if 0%{?fedora} == 28
%define _group System Environment/Daemons
%define epoch 1
Epoch: %{epoch}
Requires(pre): shadow-utils
Requires: systemd
Requires: openssl >= 1.0.1
Requires: openssh-server >= 4.4
BuildRequires: systemd-units
BuildRequires: openssl-devel >= 1.0.1
%endif

%if 0%{?fedora} == 27
%define _group System Environment/Daemons
%define epoch 1
Epoch: %{epoch}
Requires(pre): shadow-utils
Requires: systemd
Requires: openssl >= 1.0.1
Requires: openssh-server >= 4.4
BuildRequires: systemd-units
BuildRequires: openssl-devel >= 1.0.1
%endif

%if 0%{?fedora} == 26
%define _group System Environment/Daemons
%define epoch 1
Epoch: %{epoch}
Requires(pre): shadow-utils
Requires: systemd
Requires: openssl >= 1.0.1
Requires: openssh-server >= 4.4
BuildRequires: systemd-units
BuildRequires: openssl-devel >= 1.0.1
%endif

%if 0%{?fedora} == 25
%define _group System Environment/Daemons
%define epoch 1
Epoch: %{epoch}
Requires(pre): shadow-utils
Requires: systemd
Requires: openssl >= 1.0.1
Requires: openssh-server >= 4.4
BuildRequires: systemd-units
BuildRequires: openssl-devel >= 1.0.1
%endif

%if 0%{?suse_version} == 1315
%define _group Productivity/Networking/Web/Servers
%define nginx_loggroup trusted
Requires(pre): shadow
Requires: systemd
BuildRequires: libopenssl-devel
BuildRequires: systemd
%endif

## end of distribution specific definitions

Name:	recording	
Version: 1.0
Release: 1%{?dist}
Summary: Records of user sessions

License: GPLv3
URL: https://devopszone.org
Source0: https://delyanyanev.fedorapeople.org/recording-1.0-1.tar.gz

BuildRoot: %{_tmppath}/%{name}-%{main_version}-%{main_release}-root

%description
This is rpm package on whole process of recording.


%prep
%setup -q
%global debug_package %{nil}

%build


%install

%{__mkdir} -p $RPM_BUILD_ROOT/var/records
%{__mkdir} -p $RPM_BUILD_ROOT/usr/local/sbin/recording
%{__mkdir} -p $RPM_BUILD_ROOT/etc/profile.d

%{__install} -m750 1second.sh \
    $RPM_BUILD_ROOT/usr/local/sbin/recording/1second.sh

%{__install} -m755 log-session \
    $RPM_BUILD_ROOT/usr/local/sbin/recording/log-session

%{__install} -m640 README \
    $RPM_BUILD_ROOT/usr/local/sbin/recording/README

%{__install} -m750 setimmut.sh \
    $RPM_BUILD_ROOT/usr/local/sbin/recording/setimmut.sh

%{__install} -m644 recording.sh \
    $RPM_BUILD_ROOT/etc/profile.d/recording.sh


%if %{use_systemd}
# install systemd-specific files
%{__mkdir} -p $RPM_BUILD_ROOT%{_unitdir}
%{__install} -m644 recording.service \
    $RPM_BUILD_ROOT%{_unitdir}/recording.service
%else
# install SYSV init stuff
%{__mkdir} -p $RPM_BUILD_ROOT%{_initrddir}
%{__install} -m755 recording.init $RPM_BUILD_ROOT%{_initrddir}/recording
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
cat >> /etc/ssh/sshd_config <<EOF
Match	User	*,!root
	ForceCommand /usr/local/sbin/recording/log-session
EOF

%if %{use_systemd}
/usr/bin/systemctl reload sshd.service
/usr/bin/systemctl enable recording.service
/usr/bin/systemctl start recording.service
%else
/sbin/service sshd reload
/sbin/chkconfig --add recording
/sbin/service recording start
%endif

%files
/usr/local/sbin/recording/1second.sh
/usr/local/sbin/recording/setimmut.sh
/usr/local/sbin/recording/log-session
/usr/local/sbin/recording/README

%if %{use_systemd}
%{_unitdir}/recording.service
%else
/etc/rc.d/init.d/recording
%endif

/etc/profile.d/recording.sh

%dir
%attr(0753, root, root) /var/records
%attr(-, root, root) /usr/local/sbin/recording

%changelog
* Mon Jun 05 2017 Delyan Yanev <delyanyanev@yahoo.com> - 1.0.1
- Build first version of package

%preun

%if %{use_systemd}
/usr/bin/systemctl --no-reload disable recording.service >/dev/null 2>&1 ||:
/usr/bin/systemctl stop recording.service >/dev/null 2>&1 ||:
%else
/sbin/chkconfig --del recording
/sbin/service recording stop
%endif

%postun
sed -n -i -e '/log-session/{s/.*//;x;d;};x;p;${x;p;}' /etc/ssh/sshd_config | sed '/^$/d'

%if %{use_systemd}
/usr/bin/systemctl reload sshd.service
/usr/bin/systemctl daemon-reload >/dev/null 2>&1
%else
/sbin/service sshd reload
%endif
